function [y, wout,A, selectedIndex] = multiobj(X, t, threshold, w0, learningRate, mu0, lambda0, gamma, maxIter, OverValue,onlyAutocorr)
% Multiobjective constraint optimization using Lagrange multipliers
%
% Command:
%   [y, w] = multiobj(X, t, threshold, w0, learningRate, mu0, lambda0, gamma, maxIter, OverValue)??
%
% Parameters:
%            y --- extracted source signal, according to the given optimal time delay.
%            w --- corresponding weight vector, that is, y=w'*X.
%            X --- prewhitened observed mixed signals. Each row is a mixed signal.
%          ref --- reference signal, which can be generated by function genRectangleRef
%                  and genPulseRef
%    threshold --- the closeness of the desired signal and the reference signal is less than
%                  or equal to the threshold, i.e., closeness(y,ref) - threshold <= 0
%           w0 --- the initial weight vector
% learningRate --- learning rate of the weight w
%          mu0 --- the Lagrange multiplier for constraint g(w)
%      lambda0 --- the Lagrange multiplier for constraint h(w)
%        gamma --- the scalar penalty parameter
%  OverValue --- stopping criterion, say, 0.0001. When the changed value
%                of weighted vector is less than it, then the algorithm stops
%    maxIter --- maximum iterations for estimating each independent component


fprintf('Starting multi objective optimization for extracting the desired source signal ..\n');


mu = mu0;
lambda = lambda0;
convergedFlag = 1;
loop = 1;
[ICnum, IClen]=size(X);
vectorSize=ICnum;
addpath('../tools/FastICA');
firstEig=1;
lastEig=ICnum;
interactivePCA='off';
verbose='on';

mixedsig=X;
mixedmean=mean(X,2);
if ~onlyAutocorr
    [E, D]=pcamat(X, firstEig, lastEig, interactivePCA, verbose);
    % Calculate the whitening
    [whitesig, whiteningMatrix, dewhiteningMatrix] = whitenv(X, E, D, verbose);
    X=whitesig;
end
    
if size(X,1)==1
    wout=w0;
    y=X;
    convergedFlag=0;
    return;
end
% w=whiteningMatrix*w0;
% w=w/norm(w);
% oldw=w;
ICnum=size(X,1);
if ICnum<vectorSize
    fprintf(2,'Dimensions reduced to %d !\n',ICnum);
    vectorSize=ICnum;
    initialStateMode=0;
end
w=w0;
oldw=w;
% compute the autocorrelation matrix Rxx
Rxx = X(:,1:end) * X(:,1:end)' / IClen;


%W constraints, maximize these differences
%g(w)=zeta-||w2|-|w3||<0
zeta=4000;
mu1=10;
soln=[w;zeta;0];
gamma1=1;
%For ICA
%gamma=eye(ICnum);
%lambda=eye(ICnum);
%gamma=1; lambda=1;
%Get the nadir and ideal objective vectors for negentropy and
%autocorrelation
% [znad,zi]=getObjVecMulti(t);
% %For negentropy
% if onlyAutocorr
%         mulJ=0;
% else
%     mulJ=1/(znad(1)-zi(1));
% end
% %For autocorrelation
% mulR=1/(znad(2)-zi(2));
h = mean((w'*X)'.^2) - 1;                    
while (convergedFlag == 1)
    
    % output at current iteration
    y = w' * X;
    if ~onlyAutocorr
        W=dewhiteningMatrix*w;
        W=W/norm(W);
    end
    % calculate the first order deviation of the Lagarange function
    std_y = std(y);                          % standard deviation
    v_Gaus = normrnd(0, std_y, 1, IClen);    % Gaussian signal with the same mean and variance
    rou = mean( log(cosh(y)) - log(cosh(v_Gaus)) );
    g = abs(w(3))-abs(w(2))+zeta;
    %     objf=tanh(y) - tanh(v_Gaus);
    %     rou = mean( objf );
    
    %objf=mean(( X * tanh(y)'));
    %First and second derivatives of negentropy
    J1=tanh(y); J2=1-tanh(y).^2;
    g1=[0;-sign(w(2));sign(w(3))];
    g2=zeros(numel(w));
    
    %First and second derivatives of autocorrelation
    %R1=X*r1y'/N and R2=X*r2y*X'/N
    [R,R1,R2]=autocorrd(y,X,1/mean(diff(t)));
   
    %First and second derivatives of w constraint
    
    %Normalize J1 and R
%     J1=J1*mulJ;   R1= R1*mulR;
%     J2=J2*mulJ;   R2= R2*mulR;
%     mu1=0;mu2=0; 
%     lambda=0;
    h1=( X * y')/IClen;
    L1 = sign(rou) * ( X * J1' )/IClen - lambda * h1 - mu1*R1;
    %Add -gi(w) as rows to the end of L1
    L1 = [L1;mean(R.*R)-zeta;-h];
    
    %Add -g'i(w) to the last row and column(transposed). Last element being
    %0
    L2 =sign(rou) *  mean(J2').*Rxx - lambda*Rxx  -mu1*R2 ;
    L2 = [L2, -R1,-h1;[[-R1';-h1'],zeros(2)]];
    
    % update of the weight vector
    soln = soln - learningRate*pinv(L2)* L1;   %Eqn 17
    w=soln(1:3);
    w = w * real(inv(w' * w)^(1/2));
    
    
    
    % update of parameter mu1 and mu2
%     g1=(W'*c1).^2-tw;
%     g2=(W'*c2).^2-tw;
      mu1 = mu1 + gamma1 * (zeta-mean(R.*R));
%     mu2 = mu2 + gamma * g2;
    
    % update of the parameter lambda
    h = mean(y'.^2) - 1;                    % corresponds to the equality constraint
    %lambda = lambda + gamma * h;                 %Eqn 19
    lambda = lambda + gamma * h;
    
    % decide whether the algorithm has converged or not
    %wchange = 1-abs(w'*oldw);
    wchange= 1 - min(abs(diag(w' * oldw)));
    fprintf('No.%d iteration: change in w is %g\n',loop, wchange);
    if wchange < OverValue
        fprintf('Converged after %d iteration\n',loop);
        convergedFlag = 0;
    end
    
    if loop >= maxIter
        %fprintf('After %d iteration, still cannot convergent.\n',loop);
        convergedFlag = 2;
    end
    
    oldw = w;
    loop = loop + 1;
    
end

%y = w'* X;
% output
Fs=1/mean(diff(t));
if ~onlyAutocorr
    W=w'*whiteningMatrix;
    A=dewhiteningMatrix*w;
else
    W=w';
    A=w';
end
y =  W * mixedsig + (W * mixedmean) * ones(1, IClen);
result=y';
selectedSig=[];
selectedIndex=0;
if true
    LOW_F=0.7; % low freq for BP filtering
    UP_F=3; % high freq for BP filtering
    WIDTH = 0.1; % Width for the door step function to compute SNR (in Hz)
    
    maxsnr = 0;
    %figure('units','normalized','outerposition',[0 0 1 1]);hold on;
    for index=1:size(result,2)
        
        x = result(:,index);
        N = length(x)*3;
        sig_freq = [0 : N-1]*Fs/N;
        sig_power = abs(fft(x,N)).^2;
        
        %         fig3 = figure(3);
        %         clf(fig3);
        %         plot(sig_freq, sig_power), xlim([0.3 3.5]), xlabel('Heart Rate (Hz)');
        %         title('rPPG FFT')
        
        range = (sig_freq>LOW_F & sig_freq < UP_F);   % frequency range to find PSD peak
        sig_power = sig_power(range);
        sig_freq = sig_freq(range);
        [sig_peakPower,loc] = max(sig_power); % findpeaks(sig_power,'SortStr','descend','NPeaks',1); % get first peak
        sig_peakLoc = sig_freq(loc);
        peaksPower(index) = sig_peakPower;
        
        range = (sig_freq>(sig_peakLoc-WIDTH/2) & sig_freq < (sig_peakLoc+WIDTH/2))';
        signal = sig_power.*range;
        noise = sig_power.*(~range);
       

%         

    
    
        n = sum(noise);
        s = sum(signal);
        snr = s/n;
        
        %[G,g1,g2]=autocorrd(x',result',1/mean(diff(t)));
%         G(1:round(0.7*30))=0;
%         G(3*30:end)=0;
        %Gmean=mean(G.*G);
        
%         subplot(1,3,index),plot(sig_freq, signal, 'r'), xlim([0.3 3.5]), xlabel('Heart Rate (Hz)');hold on;
%         subplot(1,3,index),plot(sig_freq, noise, 'b'), xlim([0.3 3.5]), xlabel('Heart Rate (Hz)');
%         title('rPPG FFT')
%         annotation('textbox',[0.2*(index+0.1) 0.5 0.2 0.3], 'String',['snr=' num2str(snr) 'Gmean=' num2str(Gmean)],'FitBoxToText','on');
%         hold off;
                
        
        if snr>maxsnr
            maxsnr=snr;
            selectedSig=x';
            selectedIndex=index;
        end
    end
    
    selectedSig=selectedSig';
    if selectedSig(1)>0
        selectedSig=selectedSig*(-1);
    else
    end
end
%Dewhitened separation matrix
wout=w;
y=selectedSig;
fprintf('End of multiobjective optimization!\n');

